[inseparable changes from patch to perl 5.004_04]
[p5sagit/p5-mst-13.2.git] / ext / util / make_ext
index bfbcc83..70a5d2e 100644 (file)
@@ -4,16 +4,35 @@
 # It primarily used by the perl Makefile:
 #
 # d_dummy $(dynamic_ext): miniperl preplibrary FORCE
-#        ext/util/make_ext dynamic $@
+#      @sh ext/util/make_ext dynamic $@ MAKE=$(MAKE) LIBPERL_A=$(LIBPERL)
 #
 # It may be deleted in a later release of perl so try to
 # avoid using it for other purposes.
 
 target=$1;  shift
 extspec=$1; shift
+makecmd=$1; shift  # Should be something like MAKE=make
 passthru="$*" # allow extra macro=value to be passed through
 echo ""
 
+# Previously, $make was taken from config.sh.  However, the user might
+# instead be running a possibly incompatible make.  This might happen if
+# the user types "gmake" instead of a plain "make", for example.  The
+# correct current value of MAKE will come through from the main perl
+# makefile as MAKE=/whatever/make in $makecmd.  We'll be cautious in
+# case third party users of this script (are there any?) don't have the
+# MAKE=$(MAKE) argument, which was added after 5.004_03.
+case "$makecmd" in
+MAKE=*)
+       eval $makecmd
+       ;;
+*)     echo 'ext/util/make_ext:  WARNING:  Please include MAKE=$(MAKE)'
+       echo '  in your call to make_ext.  See ext/util/make_ext for details.'
+       exit 1
+       ;;
+esac
+
+
 case $CONFIG in
 '')
     if test -f config.sh; then TOP=.;
@@ -107,10 +126,10 @@ clean)            ;;
 realclean)     ;;
 *)     # Give makefile an opportunity to rewrite itself.
        # reassure users that life goes on...
-       $make config $passthru || echo "$make config failed, continuing anyway..."
+       $MAKE config $passthru || echo "$MAKE config failed, continuing anyway..."
        ;;
 esac
 
-$make $makeopts $target $makeargs $passthru || exit
+$MAKE $makeopts $target $makeargs $passthru || exit
 
 exit $?